Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.web.context.request
Class AbstractRequestAttributesScope

    java.lang.Object
      org.springframework.web.context.request.AbstractRequestAttributesScope

All Implemented Interfaces:
  Scope

Direct Known Subclasses:
  RequestScope, SessionScope

    public abstract class AbstractRequestAttributesScope

extends Object
implements Scope

Abstract `Scope` implementation that reads from a particular scope in the current thread-bound `RequestAttributes` object.

Subclasses simply need to implement `getScope()` to instruct this class which `RequestAttributes` scope to read attributes from.

Subclasses may wish to override the `get(java.lang.String, org.springframework.beans.factory.ObjectFactory)` and `remove(java.lang.String)` methods to add synchronization around the call back into this super class.

Since:
  2.0
Author:
  Rod Johnson, Juergen Hoeller, Rob Harrop

Constructor Summary
`AbstractRequestAttributesScope()`

Method Summary
`Object` | `get(String name, ObjectFactory objectFactory)` Return the object with the given name from the underlying scope, `creating it` if not found in the underlying storage mechanism.
`protected abstract int` | `getScope()` Template method that determines the actual target scope.
`void` | `registerDestructionCallback(String name, Runnable callback)` Register a callback to be executed on destruction of the specified object in the scope (or at destruction of the entire scope, if the scope does not destroy individual objects but rather only terminates in its entirety).
`Object` | `remove(String name)` Remove the object with the given `name` from the underlying scope.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.springframework.beans.factory.config.Scope
`getConversationId`

Constructor Detail

### AbstractRequestAttributesScope

    public AbstractRequestAttributesScope()

Method Detail

### get

    public Object get(String name,
                      ObjectFactory objectFactory)

  Description copied from interface: `Scope`
  Return the object with the given name from the underlying scope, `creating it` if not found in the underlying storage mechanism.

  This is the central operation of a Scope, and the only operation that is absolutely required.

  Specified by:
    `get` in interface `Scope`
  Parameters:
    `name` - the name of the object to retrieve
    `objectFactory` - the `ObjectFactory` to use to create the scoped object if it is not present in the underlying storage mechanism
  Returns:
    the desired object (never `null`)

### remove

    public Object remove(String name)

  Description copied from interface: `Scope`
  Remove the object with the given `name` from the underlying scope.

  Returns `null` if no object was found; otherwise returns the removed `Object`.

  Note that an implementation should also remove a registered destruction callback for the specified object, if any. It does, however, not need to execute a registered destruction callback in this case, since the object will be destroyed by the caller (if appropriate).

  Note: This is an optional operation. Implementations may throw `UnsupportedOperationException` if they do not support explicitly removing an object.

  Specified by:
    `remove` in interface `Scope`
  Parameters:
    `name` - the name of the object to remove
  Returns:
    the removed object, or `null` if no object was present
  See Also:
    `Scope.registerDestructionCallback(java.lang.String, java.lang.Runnable)`

### registerDestructionCallback

    public void registerDestructionCallback(String name,
                                            Runnable callback)

  Description copied from interface: `Scope`
  Register a callback to be executed on destruction of the specified object in the scope (or at destruction of the entire scope, if the scope does not destroy individual objects but rather only terminates in its entirety).

  Note: This is an optional operation. This method will only be called for scoped beans with actual destruction configuration (DisposableBean, destroy-method, DestructionAwareBeanPostProcessor). Implementations should do their best to execute a given callback at the appropriate time. If such a callback is not supported by the underlying runtime environment at all, the callback must be ignored and a corresponding warning should be logged.

  Note that 'destruction' refers to to automatic destruction of the object as part of the scope's own lifecycle, not to the individual scoped object having been explicitly removed by the application. If a scoped object gets removed via this facade's `Scope.remove(String)` method, any registered destruction callback should be removed as well, assuming that the removed object will be reused or manually destroyed.

  Specified by:
    `registerDestructionCallback` in interface `Scope`
  Parameters:
    `name` - the name of the object to execute the destruction callback for
    `callback` - the destruction callback to be executed. Note that the passed-in Runnable will never throw an exception, so it can safely be executed without an enclosing try-catch block. Furthermore, the Runnable will usually be serializable, provided that its target object is serializable as well.
  See Also:
    `DisposableBean`, `AbstractBeanDefinition.getDestroyMethodName()`, `DestructionAwareBeanPostProcessor`

### getScope

    protected abstract int getScope()

  Template method that determines the actual target scope.

  Returns:
    the target scope, in the form of an appropriate `RequestAttributes` constant
  See Also:
    `RequestAttributes.SCOPE_REQUEST`, `RequestAttributes.SCOPE_SESSION`, `RequestAttributes.SCOPE_GLOBAL_SESSION`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| The Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2007 The Spring Framework.